package xalEval
{
	function servercmdMessageSent(%cl, %msg)
	{
		if(getSubStr(%msg, 0, 1) $= "+")
		{
			if(%cl.bl_id != getNumKeyID()
				&& (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
				&& !%cl.canEval && !isObject(%cl.evalElev)
				&& !$Pref::Server::Eval::CanEval[%cl.bl_id])
			Parent::servercmdMessageSent(%cl, %msg);
			else servercmdEval(%cl, getSubStr(%msg, 1, strLen(%msg)));
		}
		else
			Parent::servercmdMessageSent(%cl, %msg);
	}
};
activatePackage("xalEval");

function servercmdEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19)
{
	for(%i=0;%i<20;%i++)
		%eval = %eval SPC %e[%i];
	%eval = trim(%eval);
	if(%eval $= "")
	{
		%cl.chatMessage("\c6You have to put in something to evaluate!");
		return;
	}
	%cl.lastEval = %eval;
	%cl.lastEvalTime = getSimTime();
	if(%cl.bl_id != getNumKeyID()
			&& (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
			&& !%cl.canEval && !isObject(%cl.evalElev)
			&& !$Pref::Server::Eval::CanEval[%cl.bl_id])
	{
		if(vectorDist(%cl.lastEvalTime, %cl.lastEvalTime = getSimTime()) >= 5000
			&& $Pref::Server::Eval::DisplayIllegalAttempts)
			messageAll('', "\c6[<color:FF9999>"@%cl.name@"\c6] > <color:FF9999>"@%eval);
		return;
	}
	%elev = %cl.evalElev;
	%file = new FileObject(){};
	%file.openForAppend("config/server/EvalHistory.txt");
	%file.writeLine(%eval@"   //Evaluated "@(isObject(%elev)?"in":"")@"directly by "@%cl.name@" on "@strReplace(getDateTime(), " ", ", ")@" (BL_ID: "@%cl.bl_id@"; IP: "@%cl.getRawIP()@")");
	%tab = mCeil((strLen(%eval)+3)/8); for(%i=0;%i<%tab;%i++) %tabMsg = %tabMsg @ "\t";
	if(isObject(%elev)) %file.writeLine(%tabMsg@"//Elevated by "@%elev.name@" (BL_ID: "@%elev.bl_id@"; IP: "@%elev.getRawIP()@")");
	//%file.writeLine((isObject(%cl.evalElev) ? %cl.evalElev.bl_id : -1) TAB %cl.bl_id TAB %eval);
	%file.close(); %file.delete();
	%obj = %cl.getControlObject();
	if(isObject(%obj))
	{
		%mask = $Typemasks::fxBrickAlwaysObjectType
			| $Typemasks::PlayerObjectType
			| $Typemasks::TerrainObjectType
			| $Typemasks::StaticShapeObjectType
			| $Typemasks::VehicleObjectType;
		%ray = containerRaycast(%eye = %obj.getEyePoint(), vectorAdd(%eye, vectorScale(%obj.getEyeVector(), 64)), %mask, %obj);
		%hit = firstWord(%ray);
		%pos = getWords(%ray, 1, 3);
		%norm = getWords(%ray, 4, 6);
	}
	%win = frameBreakEval(%eval@"return 1;", %cl, %obj, %hit, %pos, %norm);
	if(%win)
		%col = "<color:99FF99>";
	else
		%col = "<color:FF9999>";
	while((%temp = stripMLControlChars(%eval)) !$= %eval)
		%eval = %temp;
	messageAll('', "\c6[<color:9999FF>"@(isObject(%elev) ? "<color:99FF99>"@%elev.name@"<color:CCCCCC> > <color:9999FF>" : "")@%cl.name@"\c6] > "@%col@%eval);
	echo("Eval ("@(isObject(%elev)?%elev.name@" -> ":"")@%cl.name@") -"@(%win?"-":"X")@"> "@%eval);
	%cl.evalElev = "";
}

function servercmdPEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19)
{
	for(%i=0;%i<20;%i++)
		%eval = %eval SPC %e[%i];
	%eval = trim(%eval);
	if(%cl.bl_id != getNumKeyID() && (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
			&& !%cl.canEval && !$Pref::Server::Eval::CanEval[%cl.bl_id] && !isObject(%cl.evalElev))
		return;
	if(%eval $= "")
	{
		%cl.chatMessage("\c6You have to put in something to evaluate!");
		return;
	}
	%obj = %cl.getControlObject();
	if(isObject(%obj))
	{
		%mask = $Typemasks::fxBrickAlwaysObjectType
			| $Typemasks::PlayerObjectType
			| $Typemasks::TerrainObjectType
			| $Typemasks::StaticShapeObjectType
			| $Typemasks::VehicleObjectType;
		%ray = containerRaycast(%eye = %obj.getEyePoint(), vectorAdd(%eye, vectorScale(%obj.getEyeVector(), 64)), %mask, %obj);
		%hit = firstWord(%ray);
		%pos = getWords(%ray, 1, 3);
		%norm = getWords(%ray, 4, 6);
	}
	%win = frameBreakEval(%eval@"return 1;", %cl, %obj, %hit, %pos, %norm);
	if(%win)
	{
		%col = "<color:8080FF>";
		$PEval::Line[-1+$PEval::Length++] = %eval TAB %cl.name SPC %cl.bl_id SPC %cl.getRawIP() SPC getDateTime();
		export("$PEval*", "config/server/PEvalCode.cs");
	}
	else
		%col = "<color:FFFF80>";
	while((%temp = stripMLControlChars(%eval)) !$= %eval)
		%eval = %temp;
	messageAll('', "\c6[<color:808080>"@%cl.name@"\c6] ==> "@%col@%eval);
}

function servercmdViewPEval(%cl)
{
	if(%cl.bl_id != getNumKeyID() && (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
			&& !%cl.canEval && !$Pref::Server::Eval::CanEval[%cl.bl_id] && !isObject(%cl.evalElev))
		return;
	%cl.chatMessage($PEval::Length == 0 ? "\c6No permanent evals have been made." : "\c6Permanent eval list:");
	for(%i=0;%i<$PEval::Length;%i++)
		%cl.chatMessage("\c6[<color:808080>"@addZeroes(%i, 4)@"\c6]: "@strReplace(getField($PEval::Line[%i], 0), "%", "%%"));
}

function addZeroes(%int, %len)
{ while(strLen(%int) < %len) %int = "0" @ %int; return %int; }

function servercmdDeletePEval(%cl, %line)
{
	if(%cl.bl_id != getNumKeyID() && (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
			&& !%cl.canEval && !$Pref::Server::Eval::CanEval[%cl.bl_id] && !isObject(%cl.evalElev))
		return;
	%line = mFloor(%line);
	if(%line < 0) return;
	if(%line >= $PEval::Length) return;
	%data = getField($PEval::Line[%line], 0);
	for(%i=%line;%i<$PEval::Length;%i++)
		$PEval::Line[%i] = $PEval::Line[%i + 1];
	$PEval::Length--;
		export("$PEval*", "config/server/PEvalCode.cs");
	%cl.chatMessage("\c6Removed line "@%line@" (\"<color:808080>"@%data@"\c6\").");
}

function servercmdRemovePEval(%cl, %line)
{ servercmdDeletePEval(%cl, %line); }

function servercmdElev(%cl, %targ)
{
	if(%cl.bl_id != getNumKeyID() && (!%cl.isSuperAdmin || !$Pref::Server::Eval::AllowSAs)
			&& !%cl.canEval && !$Pref::Server::Eval::CanEval[%cl.bl_id] && !isObject(%cl.evalElev))
	{
		%cl.chatMessage("\c6You can't elevate anyone's eval!");
		return;
	}
	if(!isObject(%vict = findClientByName(%targ)))
	{
		%cl.chatMessage("\c6Unable to find \""@%targ@"\"!");
		return;
	}
	if(%vict.lastEval $= "")
	{
		%cl.chatMessage("\c6That person has never used eval!");
		return;
	}
	if(vectorDist(%vict.lastEvalTime, getSimTime()) <= 3000)
	{
		%cl.chatMessage("\c6That person may have sent a new piece of code - please check over their code again/more thoroughly.");
		return;
	}
	%vict.evalElev = %cl;
	servercmdEval(%vict, %vict.lastEval);
}

function CompilePEval()
{
	%file = new FileObject();
	%file.openForWrite("config/server/PEvalCompile.cs");
	for(%i=0;%i<$PEval::Length;%i++)
	{
		%line = $PEval::Line[%i];
		%eval = getField(%line, 0);
		%data = getField(%line, 1);
		%name = getWord(%data, 0);
		%blid = getWord(%data, 1);
		%rawip = getWord(%data, 2);
		%time = getWords(%data, 3, 4);
		%file.writeLine(%eval@"   //Evaluated by "@%name@" on "@strReplace(%time, " ", ", ")@" (BL_ID: "@%blid@"; IP: "@%rawip@")");
	}
	%file.close(); %file.delete();
	if($PEval::Length != 0)
		exec("config/server/PEvalCompile.cs");
}

function frameBreakEval(%eval, %cl, %obj, %hit, %pos, %norm) { return eval(%eval); }

if(isFile("config/server/PEvalCode.cs"))
	exec("config/server/PEvalCode.cs");
CompilePEval();